VERSION 5.00
Begin VB.Form Test 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "0"
   ClientHeight    =   7275
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7965
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   12
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00000000&
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   485
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   531
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   360
      Top             =   5520
   End
End
Attribute VB_Name = "Test"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim SprBack As New SR2D_Sprite
Dim Spr1 As New SR2D_Sprite
Dim Spr2 As New SR2D_Sprite
Dim pX() As Long
Dim pY() As Long
Dim FPS As Long
Dim EnClr As Boolean
Dim EnShow As Boolean
Dim tMode As Long

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  Select Case KeyCode
    Case vbKeyEscape
      Unload Me
    Case vbKeyC
      EnClr = Not EnClr
    Case vbKeyS
      EnShow = Not EnShow
    Case vbKey1
      tMode = 1
      Spr1.LoadFromFile "tree1.png", , 800, 600
    Case vbKey2
      tMode = 2
      Spr1.LoadFromFile "tree1.png", , 128, 128
    Case vbKey3
      tMode = 3
      Spr1.LoadFromFile "tree1.png", , 512, 512
    Case vbKey4
      tMode = 4
      Spr1.LoadFromFile "tree1.png", , 512, 512
  End Select
End Sub

Private Sub Form_Load()
  Move Left, Top, Width - Screen.TwipsPerPixelX * (ScaleWidth - 800), Height - Screen.TwipsPerPixelY * (ScaleHeight - 600)
  ScaleMode = vbPixels
  Show
  SprBack.Init 800, 600
  Spr1.LoadFromFile "tree1.png", , 800, 600
  Spr2.Init 600, 600
  EnClr = True
  EnShow = True
  tMode = 1
  Do While DoEvents
    Render
    FPS = FPS + 1
  Loop
End Sub

Private Sub Render()
  Dim i As Long
  Dim x As Long, y As Long
  Static bs As Single
  Static a As Double

  a = a + 0.003
  If EnClr Then
    bs = bs + 0.1
    If bs > 255 Then bs = 0
    SprBack.ClearBuffer ARGB(0, 60, 89, bs)
  End If
  
  Select Case tMode
    Case 1
      SprBack.Draw Spr1, 0, 0, OpAlphaBlend
    Case 2
      For i = 0 To 99
        x = (i Mod 10) * 75
        y = (i \ 10) * 53
        SprBack.Draw Spr1, x, y, OpAlphaBlend
      Next i
    Case 3
      Spr2.DrawRotate Spr1, 256, 256, 300, 300, a, False
      SprBack.Draw Spr2, 100, 0, OpAlphaBlend
    Case 4
      Spr2.DrawRotate Spr1, 256, 256, 300, 300, a, True
      SprBack.Draw Spr2, 100, 0, OpAlphaBlend
  End Select
  
  If EnShow Then SprBack.PaintToHDC hDC
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  Set Spr1 = Nothing
  Set SprBack = Nothing
End Sub

Private Sub Timer1_Timer()
  Caption = FPS
  FPS = 0
End Sub
